-- This file is part of Hypha.
--
-- Hypha is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- Hypha is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with Hypha.  If not, see <http://www.gnu.org/licenses/>.
--
-- Copyright 2013 Luca Padovani

module Process where

type Name = String

data Process a =
    Idle
  | Send Expression Expression (Process a)
  | Receive Expression Name a (Process a)
  | Star (Process a)
  | Par (Process a) (Process a)
  | New Name a (Process a)
  | Group (Process a)
  | Let Name a Name a Expression (Process a)
  | Case Expression Name a (Process a) Name a (Process a)
    deriving (Show)

data Expression =
    Id Name
  | UNIT
  | INT Int
  | IntBinOp Expression Expression
  | LogBinOp Expression Expression
  | RelOp Expression Expression
  | LogUnOp Expression
  | Pair Expression Expression
  | Left Expression
  | Right Expression
  | First Expression
  | Second Expression
    deriving (Show)

